<?php

/*
Plugin Name: 404 Redirector
Plugin URI: http://
Description: You just transfered your homepage to Wordpress, still having links to your former site? 404 Redirector will look for these content.
Version: 0.5
Author: Nico Haase
Author URI: http://www.nicohaase.de
*/ 

/*  Copyright 2007  Nico Haase  (email : nico.haase@gmx.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function redirect404_init()
 {
 	add_action('admin_menu', 'redirect404_menu');
 }

function redirect404_menu()
 {
 	add_submenu_page ( 'plugins.php', '404 Redirector', '404 Redirector - Konfiguration', 'manage_options', 'redirect404', 'redirect404_show_config' );
 }
 
function redirect404_show_config()
 {
 	if ( !empty($_POST ) ) 
 	 {
	 	if ( isset ( $_POST['redirect404_activated'] ) )
 	 	 {
 	 	 	update_option ( 'redirect404_activated', 'true' );
 	 	 }
 	 	else
 	 	 {
 	 	 	update_option ( 'redirect404_activated', 'false' );
 	 	 }
 	 	update_option ( 'redirect404_directory', $_POST['redirect404_directory'] );
 	 	update_option ( 'redirect404_url', $_POST['redirect404_url'] );
 	 	
 	 	echo '<div id="message" class="updated fade"><p><strong>' .  __('Options saved.') . '</strong></p></div>';
 	 }
 	 
 	 
 	echo '<div class="wrap">';
 	
 	echo '<h2>404 Redirector - Konfiguration</h2>';

	echo '<div class="narrow">';
 	echo '<form action="" method="post" id="redirect404-config" style="margin: auto; width: 600px; ">';
 	echo '<input type = "checkbox" name = "redirect404_activated" value = "true" ' . ( get_option('redirect404_activated') == 'true' ? ' checked="checked" ' : '' ) . '> aktiviert?<br>';
 	echo 'Position im Dateisystem (ohne abschlie&szlig;enden Slash): <input type = "text" size = 40 name = "redirect404_directory" value = "' . get_option ( 'redirect404_directory' ) . '"><br>';
 	echo 'Erreichbarkeit per URL (ohne abschlie&szlig;enden Slash): <input type = "text" size = 40 name = "redirect404_url" value = "' . get_option ( 'redirect404_url' ) . '"><br>';
 	
 	echo '<br><p class="submit"><input type="submit" name="submit" value="' . __('Update options &raquo;') . '" /></p>'; 	
 	echo '</form></div></div>'; 

 }

function redirect404() {
	if (is_404() && get_option ( 'redirect404_activated' ) == 'true' ) {
		
		$directory = get_option ( 'redirect404_directory' );
		$URL = get_option ( 'redirect404_url' );
		
		$searchFor = $_SERVER['REQUEST_URI'];	
		
		if ( is_file ( $directory . $searchFor ) || is_dir ( $directory . $searchFor ) )
		 {
		 	header("Location: " . $URL . $searchFor );	
		 	exit;
		 }
	}
}

add_action('init', 'redirect404_init');
add_action('wp', 'redirect404');

?>